/*
 * Created on 11-giu-2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package hipi.compiler.checker;

import hipi.compiler.*;


/**
 * Visitor used to add recDefs, local name declarations and type identifiers
 * into the symbol table
 * 
 * @author PAOLO
 */
public class TreeCheckerFirstVisitor implements HiPiCompilerVisitor {

	// reference to the parser (for error messages)
	private HiPiCompiler parser;

	// default constructor
	TreeCheckerFirstVisitor(HiPiCompiler p) {
		parser = p;
	}

	public Object visit(SimpleNode node, Object data) {
		return null;
	}

	public Object visit(ASTHiPiProgram node, Object data) {
		return null;
	}

	public Object visit(ASTGlobalChannelDeclaration node, Object data) {
		return null;
	}

	public Object visit(ASTRecursiveDefinition node, Object data) {
		SymbolTable symbolTable = ((TreeCheckerData) data).symbolTable;
		STE_Definition steDef = new STE_Definition(node.name, node.type);
		if (node.params != null)   
			// TODO CAMBIARE: CI VOGLIONO CLASSI PER I TIPI
			//steDef.setChannelParams(((ASTRecursiveDefinition) child).params);
			// this is for type checking
			{}
		try {
			symbolTable.addElement(steDef);
		} catch (SymbolTableException ste) {
			parser.hipi_syntax_error(node,ste.toString());
			return null;
		}
		return null;
	}

	public Object visit(ASTSchedule node, Object data) {
		return null;
	}

	public Object visit(ASTBlock node, Object data) {
		return null;
	}

	public Object visit(ASTLocalDeclarationStatement node, Object data) {
		SymbolTable symbolTable = ((TreeCheckerData) data).symbolTable;
		try {
			node.envIndex = TreeChecker.chooseIndex(((TreeCheckerData) data).indexSet);
			// TODO: better type checking
			if (node.type==Types.CHANNEL) 
				symbolTable.addElement(
					new STE_Channel(node.name, node.params, false, node.envIndex));
			else
				symbolTable.addElement(
					new STE_Generic(node.name, node.type, node.envIndex));
		}
		catch (SymbolTableException ste) {
				parser.hipi_syntax_error(node,ste.toString());
		}
		
		node.childrenAccept(this,data);		
		node.TC_visited = true;
		return null;
	}

	public Object visit(ASTSend node, Object data) {
		return null;
	}

	public Object visit(ASTRecv node, Object data) {
		return null;
	}

	public Object visit(ASTRecursiveDefinitionCall node, Object data) {
		return null;
	}

	public Object visit(ASTSpawnStatement node, Object data) {
		return null;
	}

	public Object visit(ASTSelectionStatement node, Object data) {
		return null;
	}

	public Object visit(ASTExpOp node, Object data) {
		return null;
	}

	public Object visit(ASTNewChannel node, Object data) {
		return null;
	}

	public Object visit(ASTReturnStatement node, Object data) {
		return null;
	}

	public Object visit(ASTScheduleMain node, Object data) {
		return null;
	}

	public Object visit(ASTExpIdentifier node, Object data) {
		return null;
	}

	public Object visit(ASTExpInteger node, Object data) {
		return null;
	}

	public Object visit(ASTExpString node, Object data) {
		return null;
	}

	public Object visit(ASTTypeDeclaration node, Object data) {	
		return null;
	}

	public Object visit(ASTImportDeclaration node, Object data) {
		return null;
	}

}
